using System;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;

namespace PhotoMosaic
{
    public partial class Form1 : Form
    {
        private Image _BaseImage;                       //\摜
        private float _rate;                            //݂̊g{
        private Point _MouseDownPoint = Point.Empty;    //}EX{^ʒu
        private Boolean _bNowDrag = false;              //hbOȂtrue
        private RectangleF _ImageRect;                  //摜̈ʒuƑ傫

        /// <summary>
        /// RXgN^
        /// </summary>
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// j[I
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void IEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// j[J
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void JOToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //t@CI[v_CAO̐ݒ

            //CX^X
            OpenFileDialog dlog = new OpenFileDialog();

            //݂̃JgfBNgiʏexêꏊfBNgɐݒ
            dlog.InitialDirectory = Directory.GetCurrentDirectory();

            //tB^ݒ
            dlog.Filter = "摜t@C (*.jpg,*.png,*gif)|*.jpg;*.png;*gif|"
                                            + "SẴt@C@(*.*)|*.*";

            //Is
            dlog.Multiselect = false;

            //_CAO\
            if (dlog.ShowDialog() != DialogResult.OK)
            {
                //_CAO[J]Ȃ
                return;
            }

            String sFileName = dlog.FileName;//_CAOŎw肳ꂽt@C
            using (FileStream fStream = new FileStream(sFileName, FileMode.Open))//t@CXg[擾
            {
                if (_BaseImage != null)
                {
                    //ȑOɉ摜ǂݍłꍇAjĂ
                    _BaseImage.Dispose();
                }
                //摜ǂݍ
                _BaseImage = Image.FromStream(fStream);
                
                //EBhȆ傫ƃNCAg̈̍
                int subWidth = this.Width - this.ClientSize.Width;
                int subHeight = this.Height - this.ClientSize.Height;

                //EBhȆ傫摜̑傫ɍ킹
                this.Width = _BaseImage.Width + subWidth;
                this.Height = _BaseImage.Height + subHeight;

                //ϐ
                _rate = 1.0F;
                _ImageRect = new RectangleF(0, 0, _BaseImage.Width, _BaseImage.Height);
                _bNowDrag = false;
                _MouseDownPoint = Point.Empty;

                //tH[ɕ`˗
                this.Refresh();
            }
        }

        /// <summary>
        /// tH[[h
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void FormLoad(Object sender, EventArgs e)
        {
            //}EXCxgݒ
            this.MouseUp += new MouseEventHandler(this.pictureBox1_MouseUp);            //}EX{^𗣂
            this.MouseDown += new MouseEventHandler(this.pBox1_MouseDown);              //}EX{^
            this.MouseDoubleClick += new MouseEventHandler(this.pictureBox1_DClick);    //_uNbN
            this.MouseMove += new MouseEventHandler(this.pBox1_MouseMove);              //}EX𓮂
        }

        /// <summary>
        /// ĕ`
        /// </summary>
        /// <param name="e"></param>
        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            if (_BaseImage == null) return; //摜ǂݍ܂ĂȂ̂ŏ𔲂
            DrawImage(e.Graphics);          //`
        }

        /// <summary>
        /// }EX_E
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pBox1_MouseDown(object sender, MouseEventArgs e)
        {
            if (_BaseImage == null) return; //摜ǂݍ܂ĂȂ̂ŏ𔲂

            if (e.Button == MouseButtons.Left)
            {  //{^ꂽꍇ
                //ꂽʒuoĂ
                _MouseDownPoint = new Point(e.X, e.Y);
            }
            else
            {   //ȊÕ{^ꂽꍇ
                _bNowDrag = false;                  //DragȂ
                _MouseDownPoint = Point.Empty;      //ꂽʒuY
            }
        }

        /// <summary>
        /// }EX[uCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (_BaseImage == null) return; //摜ǂݍ܂ĂȂ̂ŏ𔲂
            if (_MouseDownPoint == Point.Empty) return; //{^ĂȂꍇ𔲂

            if (_bNowDrag)
            {   //Drag̏ꍇ

                float x = _ImageRect.X + ((_MouseDownPoint.X - e.X) * _rate);
                float y = _ImageRect.Y + ((_MouseDownPoint.Y - e.Y) * _rate);
                MoveImage(x, y);
                _MouseDownPoint.X = e.X;
                _MouseDownPoint.Y = e.Y;
            }
            else
            {   //DragȂꍇ

                //hbOƂȂ}EẌړ͈͂擾
                Rectangle moveRect = new Rectangle(
                    _MouseDownPoint.X - SystemInformation.DragSize.Width / 2,
                    _MouseDownPoint.Y - SystemInformation.DragSize.Height / 2,
                    SystemInformation.DragSize.Width,
                    SystemInformation.DragSize.Height);

                if (!moveRect.Contains(e.X,e.Y))
                {
                    //͈͊ODragɂ
                    _bNowDrag = true;
                }
            }

        }

        /// <summary>
        /// }EXAbvCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            if (_BaseImage == null) return; //摜ǂݍ܂ĂȂ̂ŏ𔲂

            _bNowDrag = false;              //DragȂ
            _MouseDownPoint = Point.Empty;  //ꏊY

            if (e.Button == MouseButtons.Right)
            {
                //E{^𗣂ꂽꍇA摜1/2ɏk
                stretch(e.X , e.Y, 0.5F);
            }
        }

        /// <summary>
        /// _uNbNCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_DClick(object sender, MouseEventArgs e)
        {
            if (_BaseImage == null) return; //摜ǂݍ܂ĂȂ̂ŏ𔲂

            if (e.Button == MouseButtons.Left)
            {
                //_uNbNꍇA摜{Ɋg
                stretch(e.X,e.Y, 2);
            }
        }

        /// <summary>
        /// gk
        /// </summary>
        /// <param name="x">}EXXW</param>
        /// <param name="y">}EXYW</param>
        /// <param name="rate">{</param>
        private void stretch(int x,int y,float rate)
        {
            if (_rate * rate < 1) return;   //{1ȉɂȂꍇ(摜菬Ȃꍇj͏Ȃ

            _rate *= rate;  //{ύX

            //gk̑傫ݒ
            _ImageRect.Width  = _rate * _BaseImage.Width;
            _ImageRect.Height = _rate * _BaseImage.Height;

            //gk̈ʒuvZ
            float mx = 0;
            float my = 0;
            if (_rate <= 1)
            {
                //̑傫ꍇiꉞ1ɐݒ肵Ȃj
                _rate = 1;
            }
            else
            {
                //2{ȏ̏ꍇ

                //_uNbNꂽʒuSɂȂ悤Ɉʒu
                mx = (x - _ImageRect.X) * rate;
                mx = -(mx - this.ClientSize.Width / 2);

                my = (y - _ImageRect.Y) * rate;
                my = -(my - this.ClientSize.Height / 2);
            }

            //摜ړiŕ`j
            MoveImage(mx, my);
        }

        /// <summary>
        /// ړ
        /// </summary>
        /// <param name="x">摜ʒu</param>
        /// <param name="y">摜ʒu</param>
        private void MoveImage(float x, float y)
        {
            if (_ImageRect.Width < this.ClientSize.Width)
            {//摜̉EBhE菬ꍇ
                //EBhE̒ɕ\
                _ImageRect.X = this.ClientSize.Width / 2 - _ImageRect.Width / 2;
            }
            else
            {   //摜EBhE傫ꍇ

                //摜ʒuEBhE̍[EɗȂ悤
                float mx = x >= 0 ? 0 : x;

                //摜ʒuEBhẺE[荶ɗȂ悤
                if (_ImageRect.Width + mx < this.ClientSize.Width) mx = this.ClientSize.Width - _ImageRect.Width;
                _ImageRect.X = mx;
            }

            if (_ImageRect.Height < this.ClientSize.Height)
            {//摜̍EBhE菬ꍇ
                //EBhE̒ɕ\
                _ImageRect.Y = this.ClientSize.Height / 2 - _ImageRect.Height / 2;
            }
            else
            {   //摜EBhE傫ꍇ

                //摜ʒuEBhȄ[艺ɗȂ悤
                float my = y >= 0 ? 0 : y;

                //摜ʒuEBhẺ[ɗȂ悤
                if (_ImageRect.Height + my < this.ClientSize.Height) my = this.ClientSize.Height - _ImageRect.Height;
                _ImageRect.Y = my;
            }

            //`˗
            this.Refresh();
        }

        /// <summary>
        /// `
        /// </summary>
        private void DrawImage(Graphics g)
        {
            //UhԂ
            g.FillRectangle(Brushes.Gray, this.ClientRectangle);

            //摜`
            g.DrawImage(_BaseImage, _ImageRect);
        }
    }
}